<?php

if (!function_exists('translateKeyWord')) {
    /**
     * Translate special key work
     * @param $keyWord
     * @return mixed
     */
    function translateKeyWord($keyWord)
    {
        if (empty($keyWord)) {
            return $keyWord;
        } else {
            return str_replace(['%'], ['\%'], $keyWord);
        }
    }
}

if (!function_exists('sendRequest')) {
    function sendRequest($url, $params = array(), $method = 'POST', $isJSON = true, $isAuthen = false, $timeOut = 60)
    {
        $request = \Ixudra\Curl\Facades\Curl::to($url)
            ->withOption('TIMEOUT', $timeOut)
            ->withOption('CONNECTTIMEOUT', 0)
            ->withOption('SSL_VERIFYPEER', 0)
            ->withContentType('application/json')
            ->withOption('FOLLOWLOCATION', true)
            ->returnResponseObject();

        if ($isJSON) {
            $request->withData(json_encode($params));
        } else {
            $request->withData($params);
        }

        if ($isAuthen) {
            $request->withOption('USERPWD', 'admin:weppoHER4352GGErfg');
        }

        $response = '';
        switch ($method) {
            case 'GET':
                $response = $request->get();
                break;
            case 'POST':
                $response = $request->post();
                break;
            case 'PUT':
                $response = $request->put();
                break;
            case 'PATCH':
                $response = $request->patch();
                break;
            case 'DELETE':
                $response = $request->delete();
                break;
            default:
                break;
        }

        return $response->content;
    }
}

if (!function_exists('getDom')) {
    function getDom($link)
    {
        $ch = curl_init($link);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $content = curl_exec($ch);
        curl_close($ch);
        $dom = \Sunra\PhpSimple\HtmlDomParser::str_get_html($content);

        return $dom;
    }
}

if (!function_exists('curlZingMp3')) {
    function curlZingMp3($url, $is_get_song_info=false) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');

        $headers = array();
        if ($is_get_song_info) {
            $headers[] = 'Authority: zingmp3.vn';
        } else {
            $headers[] = 'Authority: mp3.zing.vn';
        }
        $headers[] = 'Cache-Control: max-age=0';
        $headers[] = 'Upgrade-Insecure-Requests: 1';
        $headers[] = 'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36';
        $headers[] = 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3';
        $headers[] = 'Accept-Encoding: gzip, deflate, br';
        $headers[] = 'Accept-Language: vi-VN,vi;q=0.9,en-US;q=0.8,en;q=0.7,ja;q=0.6';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            return false;
        }
        curl_close ($ch);
        return $result;
    }
}

if (!function_exists('curlZingArtist')) {
    function curlZingArtist($url) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');

        $headers = array();
        $headers[] = 'Authority: zingmp3.vn';
        $headers[] = 'Cache-Control: max-age=0';
        $headers[] = 'Upgrade-Insecure-Requests: 1';
        $headers[] = 'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36';
        $headers[] = 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3';
        $headers[] = 'Accept-Encoding: gzip, deflate, br';
        $headers[] = 'Accept-Language: vi-VN,vi;q=0.9,en-US;q=0.8,en;q=0.7,ja;q=0.6';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            return false;
        }
        curl_close ($ch);
        return $result;
    }
}

if (!function_exists('getUrlArtistByPage')) {
    function getUrlArtistByPage($start=1, $count=100) {
        $url = 'https://zingmp3.vn/api/artist/get-list?';
        $url .= 'id=IWZ9Z08I';
        $url .= '&type=genre';
        $url .= '&sort=listen';
        $url .= '&start=' . $start;
        $url .= '&count=' . $count;
        $url .= '&ctime=1584216597';
        $url .= '&sig=e2b8e1e48ccd12f560959913a6901fc76c9b93e1cafecba2d3517d8ab57eeb44717aa41eca70338bcf8bc8c84def1c43367ef44c887589db4ed81a1e2c042303';
        $url .= '&api_key=38e8643fb0dc04e8d65b99994d3dafff';

        return $url;
    }
}

if (!function_exists('cURL')) {
    function cURL($url) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');

        //$headers = array();
        //$headers[] = 'Authority: mp3.zing.vn';
        //$headers[] = 'Cache-Control: max-age=0';
        //$headers[] = 'Upgrade-Insecure-Requests: 1';
        //$headers[] = 'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36';
        //$headers[] = 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3';
        //$headers[] = 'Accept-Encoding: gzip, deflate, br';
        //$headers[] = 'Accept-Language: vi-VN,vi;q=0.9,en-US;q=0.8,en;q=0.7,ja;q=0.6';
        //curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            return false;
        }
        curl_close ($ch);
        return $result;
    }
}

if (!function_exists('getZingUrlGetCounter')) {
    /**
     * Hàm tạo URL cho từng bài hát dựa vào ID chuỗi của nó để lấy lượt nghe
     * https://mp3.zing.vn/xhr/get-counter?id='. $idTrack .'&type=audio
     *
     * @param $id_str
     * @param string $type
     * @return string
     */
    function getZingUrlGetCounter($id_str, $type='audio') {
        $url = 'https://mp3.zing.vn/xhr/get-counter?';
        $url .= 'id=' . $id_str;
        $url .= '&type=' . $type;

        return $url;
    }
}

if (!function_exists('getNctUrlGetCounter')) {
    /**
     * Hàm tạo URL cho từng bài hát dựa vào ID của nó để lấy lượt nghe
     * https://www.nhaccuatui.com/interaction/api/counter?listSongIds=6238530
     *
     * @param $id
     * @return string
     */
    function getNctUrlGetCounter($id) {
        $url = 'https://www.nhaccuatui.com/interaction/api/counter?';
        $url .= 'listSongIds=' . $id;

        return $url;
    }
}

if (!function_exists('getKeengUrlGetCounter')) {
    /**
     * Hàm tạo URL cho từng bài hát dựa vào ID của nó để lấy lượt nghe
     * http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getSong?identify=IGm9Y2XF
     *
     * @param $id
     * @return string
     */
    function getKeengUrlGetCounter($id) {
        $url = 'http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getSong?';
        $url .= 'identify=' . $id;

        return $url;
    }
}

if (!function_exists('getKeengUrlCategoryByPopViet')) {
    /**
     * Hàm tạo URL để lấy thông tin bài hát theo chủ đề Pop Việt
     * http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getCategoryDetail?page=100&num=100&slug=pop-viet&type=1
     *
     * @param $page
     * @param $num
     * @param $slug
     * @param $type
     * @return string
     */
    function getKeengUrlCategoryByPopViet($page = 1, $num = 100, $slug = 'pop-viet', $type = 1) {
        $url = 'http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getCategoryDetail?';
        $url .= 'page=' . $page;
        $url .= '&num=' . $num;
        $url .= '&slug=' . $slug;
        $url .= '&type=' . $type;

        return $url;
    }
}

if (!function_exists('getKeengUrlNewRealease')) {
    /**
     * Hàm tạo URL để lấy thông tin bài hát theo chủ đề Pop Việt
     * http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getListSongNewV4?page=1&num=40
     *
     * @param $page
     * @param $num
     * @return string
     */
    function getKeengUrlNewRealease($page = 1, $num = 100) {
        $url = 'http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getListSongNewV4?';
        $url .= 'page=' . $page;
        $url .= '&num=' . $num;

        return $url;
    }
}

if (!function_exists('getZingSongInfoUrl')) {
    /**
     * Hàm tạo URL để lấy thông tin bài hát theo chủ đề Pop Việt
     * https://zingmp3.vn/api/song/get-song-info?id=ZWBW97D6&ctime=1586874275&sig=2024353481721f1238d558a63f76ed0b87563b91890bdda94764a7f2201ef29c4bf06bd4907312558c7d68f66f1b9c96bc1532f2670c1439b0531170d1caf225&api_key=38e8643fb0dc04e8d65b99994d3dafff
     *
     * @param $zing_id
     * @return string
     */
    function getZingSongInfoUrl($zing_id) {
        $curl = curl('http://edupham.com/api/v1/zing/get-song-info-url?zing_id='.$zing_id);
        if ($curl) {
            $response = json_decode($curl);
            if (isset($response->data)) {
                return $response->data;
            }
        }
        return null;
    }
}

if (!function_exists('getZingSongInfo')) {
    function getZingSongInfo($api_url)
    {
        $composer_name = [];

        if ($api_url) {
            $curl = curlZingMp3($api_url);
            if ($curl) {
                $response = json_decode($curl);
                if (isset($response->err) && $response->err == 0) {
                    $data = $response->data;
                    if (isset($data->composers)) {
                        $composers = $data->composers;
                        foreach ($composers as $key => $composer) {
                            $composer_name[] = $composer->name;
                        }
                    }
                }
            }
        }

        if (count($composer_name) > 0) {
            return implode(', ', $composer_name);
        }

        return null;
    }
}

if (!function_exists('convertViews')) {
    /**
     * Hàm tính toán quy đổi lượt nghe thành điểm từ các hệ thống nhạc: zing/nc/nhacvn/keeng
     *
     * @param $views_top1
     * @param $views_needed
     * @param $web
     *
     * @return string
     */
    function convertViews($views_top1, $views_needed, $web) {
        $point = 0;
        if ($views_top1 > 0 && $views_needed > 0) {
            switch ($web) {
                case 'zing': $factor = 100000; break;
                case 'nct': $factor = 94000; break;
                case 'keeng': $factor = 12000; break;
                case 'nhacvn': $factor = 14000; break;
                default: $point = 100000;
            }
            $point = $factor * ($views_needed / $views_top1);
        }
        return $point;
    }
}

if (!function_exists('saveLogFile')) {
    /**
     * Hàm lưu file log txt trong storage
     *
     * @param $file_name
     * @param $data
     * @param string $type
     *
     * @return bool
     */
    function saveLogFile($file_name, $data, $type='daily') {
        switch ($type) {
            case 'daily': $new_path = 'storage/app/public/daily_report/'; break;
            case 'weekly': $new_path = 'storage/app/public/weekly_report/'; break;
            case 'monthly': $new_path = 'storage/app/public/monthly_report/'; break;
            default: return false;
        }

        // Kiểm tra tồn tại thư mục, ko tồn tại thì tạo mới
        if (!file_exists($new_path)) {
            @mkdir($new_path, 0777, true);
        }

        // Ghi dữ liệu ra file
        $new_file_path = $new_path . $file_name;
        @copy('storage/app/public/report_template.txt', $new_file_path);
        $my_file = fopen($new_file_path, "w");
        @fwrite($my_file, $data);
        @fclose($my_file);

        //
        return true;
    }
}

if (!function_exists('getWeekDateRange')) {
    /**
     * Hàm lấy ngày đầu tiên và cuối cùng của tuần
     * @param $week
     * @param $year
     * @return mixed
     */
    function getWeekDateRange($week, $year, $format='d/m/Y', $day_start=0) {
        $dto = new DateTime();
        $dto->setISODate($year, $week, $day_start); // 0: CN
        $ret['week_start'] = $dto->format($format);
        $dto->modify('+6 days');
        $ret['week_end'] = $dto->format($format);

        return $ret;
    }
}
